package com.jiuqi.db;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.util.StringArrayOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public final class DBTrace {
  private static Object syncObj = new Object();
  
  private static boolean doTrace = false;
  
  private static Map traceFinder = new HashMap<Object, Object>();
  
  public static void createConnection(Object key) {
    if (!doTrace)
      return; 
    synchronized (syncObj) {
      TraceEntry ex = new TraceEntry(key);
      traceFinder.put(key, ex);
    } 
  }
  
  public static void closeConnection(Object key) {
    if (!doTrace)
      return; 
    synchronized (syncObj) {
      traceFinder.remove(key);
    } 
  }
  
  public static void setTrace(boolean value) {
    if (doTrace == value)
      return; 
    if (value) {
      System.out.println("Strarted Trace DB Connection Objects");
      doTrace = true;
    } else {
      System.out.println("Stoped Trace DB Connection Objects");
      traceFinder.clear();
      doTrace = false;
    } 
  }
  
  public static List getTraceResult() {
    synchronized (syncObj) {
      List<Object> result = new ArrayList();
      Iterator it = traceFinder.keySet().iterator();
      while (it.hasNext()) {
        Object obj = traceFinder.get(it.next());
        if (obj != null)
          result.add(obj); 
      } 
      return result;
    } 
  }
  
  public static List getTraceStrings() {
    List<TraceEntry> traces = getTraceResult();
    List<String[]> result = new ArrayList();
    for (int i = 0; i < traces.size(); i++) {
      StringArrayOutputStream os = new StringArrayOutputStream();
      PrintStream ps = new PrintStream((OutputStream)os);
      TraceEntry item = traces.get(i);
      item.printStackTrace(ps);
      result.add(os.toStringArray());
    } 
    return result;
  }
  
  public static boolean inTracing() {
    return doTrace;
  }
  
  public static void startLog(int fileCount, int fileSize, String fileDir) {
    PrintStream ps = new PrintStream(null, true);
    ps.flush();
  }
}
